'\"
'\" Generated from file 'tipstack\&.man' by tcllib/doctools with format 'nroff'
'\" Copyright (c) 2003 ActiveState Corp
'\"
.TH "tipstack" n 1\&.0\&.1 tklib "Tooltip management"
.\" The -*- nroff -*- definitions below are for supplemental macros used
.\" in Tcl/Tk manual entries.
.\"
.\" .AP type name in/out ?indent?
.\"	Start paragraph describing an argument to a library procedure.
.\"	type is type of argument (int, etc.), in/out is either "in", "out",
.\"	or "in/out" to describe whether procedure reads or modifies arg,
.\"	and indent is equivalent to second arg of .IP (shouldn't ever be
.\"	needed;  use .AS below instead)
.\"
.\" .AS ?type? ?name?
.\"	Give maximum sizes of arguments for setting tab stops.  Type and
.\"	name are examples of largest possible arguments that will be passed
.\"	to .AP later.  If args are omitted, default tab stops are used.
.\"
.\" .BS
.\"	Start box enclosure.  From here until next .BE, everything will be
.\"	enclosed in one large box.
.\"
.\" .BE
.\"	End of box enclosure.
.\"
.\" .CS
.\"	Begin code excerpt.
.\"
.\" .CE
.\"	End code excerpt.
.\"
.\" .VS ?version? ?br?
.\"	Begin vertical sidebar, for use in marking newly-changed parts
.\"	of man pages.  The first argument is ignored and used for recording
.\"	the version when the .VS was added, so that the sidebars can be
.\"	found and removed when they reach a certain age.  If another argument
.\"	is present, then a line break is forced before starting the sidebar.
.\"
.\" .VE
.\"	End of vertical sidebar.
.\"
.\" .DS
.\"	Begin an indented unfilled display.
.\"
.\" .DE
.\"	End of indented unfilled display.
.\"
.\" .SO ?manpage?
.\"	Start of list of standard options for a Tk widget. The manpage
.\"	argument defines where to look up the standard options; if
.\"	omitted, defaults to "options". The options follow on successive
.\"	lines, in three columns separated by tabs.
.\"
.\" .SE
.\"	End of list of standard options for a Tk widget.
.\"
.\" .OP cmdName dbName dbClass
.\"	Start of description of a specific option.  cmdName gives the
.\"	option's name as specified in the class command, dbName gives
.\"	the option's name in the option database, and dbClass gives
.\"	the option's class in the option database.
.\"
.\" .UL arg1 arg2
.\"	Print arg1 underlined, then print arg2 normally.
.\"
.\" .QW arg1 ?arg2?
.\"	Print arg1 in quotes, then arg2 normally (for trailing punctuation).
.\"
.\" .PQ arg1 ?arg2?
.\"	Print an open parenthesis, arg1 in quotes, then arg2 normally
.\"	(for trailing punctuation) and then a closing parenthesis.
.\"
.\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
.\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ta \\n()Au \\n()Bu
.ie !"\\$3"" \{\
\&\\$1 \\fI\\$2\\fP (\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
.\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
.AS Tcl_Interp Tcl_CreateInterp in/out
.\"	# BS - start boxed text
.\"	# ^y = starting y location
.\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
.\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
.\"	# VS - start vertical sidebar
.\"	# ^Y = starting y location
.\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.if !"\\$2"" .br
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
.\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
.\"	# Special macro to handle page bottom:  finish off current
.\"	# box/sidebar if in box/sidebar mode, then invoked standard
.\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
.\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
.\"	# DE - end display
.de DE
.fi
.RE
.sp
..
.\"	# SO - start of list of standard options
.de SO
'ie '\\$1'' .ds So \\fBoptions\\fR
'el .ds So \\fB\\$1\\fR
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 5.5c 11c
.ft B
..
.\"	# SE - end of list of standard options
.de SE
.fi
.ft R
.LP
See the \\*(So manual entry for details on the standard options.
..
.\"	# OP - start of full description for a single option
.de OP
.LP
.nf
.ta 4c
Command-Line Name:	\\fB\\$1\\fR
Database Name:	\\fB\\$2\\fR
Database Class:	\\fB\\$3\\fR
.fi
.IP
..
.\"	# CS - begin code excerpt
.de CS
.RS
.nf
.ta .25i .5i .75i 1i
..
.\"	# CE - end code excerpt
.de CE
.fi
.RE
..
.\"	# UL - underline word
.de UL
\\$1\l'|0\(ul'\\$2
..
.\"	# QW - apply quotation marks to word
.de QW
.ie '\\*(lq'"' ``\\$1''\\$2
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\$2
..
.\"	# PQ - apply parens and quotation marks to word
.de PQ
.ie '\\*(lq'"' (``\\$1''\\$2)\\$3
.\"" fix emacs highlighting
.el (\\*(lq\\$1\\*(rq\\$2)\\$3
..
.\"	# QR - quoted range
.de QR
.ie '\\*(lq'"' ``\\$1''\\-``\\$2''\\$3
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\-\\*(lq\\$2\\*(rq\\$3
..
.\"	# MT - "empty" string
.de MT
.QW ""
..
.BS
.SH NAME
tipstack \- Stacked tooltips
.SH SYNOPSIS
package require \fBTcl 8\&.5\fR
.sp
package require \fBmsgcat 1\&.3\fR
.sp
package require \fBtooltip ?1\&.7?\fR
.sp
package require \fBtipstack ?1\&.0\&.1?\fR
.sp
\fB::tipstack::push\fR \fIwidget\fR ?\fB-index\fR \fIindex\fR? \fItext\fR
.sp
\fB::tipstack::pop\fR \fIwidget\fR ?\fB-index\fR \fIindex\fR?
.sp
\fB::tipstack::clear\fR \fIwidget\fR ?\fB-index\fR \fIindex\fR?
.sp
\fB::tipstack::def\fR \fIwidget\fR \fItext\fR \&.\&.\&.
.sp
\fB::tipstack::defsub\fR \fIbase\fR \fIwidget\fR \fItext\fR \&.\&.\&.
.sp
\fB::tipstack::clearsub\fR \fIbase\fR
.sp
.BE
.SH DESCRIPTION
.PP
This package extends the functionality of package \fBtooltip\fR\&.
It provides a dynamic stack of tip texts per widget\&. This enables dynamic transient changes to the
tips, for example to temporarily replace a standard explanation of a field with an error message\&.
.SH COMMANDS
.TP
\fB::tipstack::push\fR \fIwidget\fR ?\fB-index\fR \fIindex\fR? \fItext\fR
Push a new \fItext\fR to the tooltip for the \fIwidget\fR\&.
In case of a list widget use
.CS

-index \&.\&.\&.
.CE
.IP to address the particular entry to change the
tooltip for\&.
.sp
The result of the command is the empty string
.TP
\fB::tipstack::pop\fR \fIwidget\fR ?\fB-index\fR \fIindex\fR?
Pop the current tooltip for the \fIwidget\fR from the stack and restore the previous text\&.
This is a no-operation if this would leave an empty stack behind\&.
In other words, the baseline tooltip text cannot be popped of\&.
In case of a list widget use
.CS

-index \&.\&.\&.
.CE
.IP to address the particular entry to change the
tooltip for\&.
.sp
The result of the command is the empty string
.TP
\fB::tipstack::clear\fR \fIwidget\fR ?\fB-index\fR \fIindex\fR?
Clear the stack for the \fIwidget\fR and restore back to the baseline\&.
In case of a list widget use
.CS

-index \&.\&.\&.
.CE
.IP to address the particular entry to change the
tooltip for\&.
.sp
The result of the command is the empty string
.TP
\fB::tipstack::def\fR \fIwidget\fR \fItext\fR \&.\&.\&.
Perform multiple pushes for a number of independent \fIwidget\fRs in a single call\&.
This command cannot be used for list widgets, as it does not allow the passing of the necessary
index information\&.
Use with menus is not possible either\&.
.sp
The result of the command is the empty string
.TP
\fB::tipstack::defsub\fR \fIbase\fR \fIwidget\fR \fItext\fR \&.\&.\&.
This command is a variant of \fB::tipstack::def\fR where all the widgets to push to are subwidgets
of the \fIbase\fR\&. This is good for mega-widgets\&.
.sp
Note that either each \fIwidget\fR has to be specified with a proper leading dot (\fB\&.\fR),
or the \fIbase\fR has to be specigfied with a trailing dot\&.
.sp
The result of the command is the empty string
.TP
\fB::tipstack::clearsub\fR \fIbase\fR
This command is a variant of \fB::tipstack::clear\fR which clears all child widgets of
the \fIbase\fR text was pushed to\&.
Use with menus is not possible\&.
.sp
The result of the command is the empty string
.PP
.SH "BUGS, IDEAS, FEEDBACK"
This document, and the package it describes, will undoubtedly contain
bugs and other problems\&.
Please report such in the category \fItooltip\fR of the
\fITklib Trackers\fR [http://core\&.tcl\&.tk/tklib/reportlist]\&.
Please also report any ideas for enhancements you may have for either
package and/or documentation\&.
.SH KEYWORDS
balloon, help, hover, tipstack
.SH COPYRIGHT
.nf
Copyright (c) 2003 ActiveState Corp

.fi
